# -*- coding: utf-8 -*-
#
# Copyright (c) 2020, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser.core import Nothing as _Nothing


class Nothing(_Nothing):
    """
    ``Nothing`` does not appear in the encoded data and not in the string or
    introspection.
    """

    def __init__(self):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(Nothing, self).__init__()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be
                decoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(Nothing, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string. This is always an empty string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(Nothing, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Always returns ``None``.

        Returns:
            None
        """
        return super(Nothing, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(Nothing, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(Nothing, self).root()

    def set(self, value):
        """
        Set the value. Always raises an Exception.

        Args:
            value: the new value
        """
        return super(Nothing, self).set(value=value)

    def set_fuzzing_values(self, values):  # pragma: no cover
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(Nothing, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Nothing, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(Nothing, self).up()

